#include "FKUT/FKUT.h"
#include "audio.h"


// vOn܂main֐
int main(int argc, char *argv[])
{
	// EBhE܁[
	fkut_SimpleWindow	window;			// ϐu3DCG`EBhEɂȂϐv

	window.setSize(800, 600);			// EBhȆ傫͂D݂
	window.setBGColor(0.3, 0.6, 0.8);	// wiFR, G, B̐F0.0`1.0Ńuhč
	window.showGuide();					// ObhƎ̕\
	window.setTrackBallMode(true);		// }EXł肮胂[h
	window.open();						// EBhÊ\
	// EBhE܂

	// \̂pӂĂ镔
	fkut_SphereModel	body;			// 삷鋅

	body.create(4, 10.0);
	body.setMaterial(Yellow);
	body.glMoveTo(0.0, 0.0, 0.0);
	window.entry(body);

	fkut_BlockModel		floor;			// 킷ubNf

	floor.create(1000.0, 1.0, 1000.0);
	floor.glMoveTo(0.0, -0.5, 0.0);		// 傢ƒ߂ɂĂ
	floor.setMaterial(Brown);
	window.entry(floor);
	// \pӕ܂

	/////////////////////////////////////////////////////////////
	// ԂubNpӂ
	fkut_BlockModel		hitBlk[10];
	// 蔻Ŏgϐ
	fk_Vector			back;
	bool				stand = false;

	// zƌJԂ𗘗pāA܂Ƃ߂Đݒ
	for(int i = 0; i < 10; i++) {
		hitBlk[i].create(30.0, 60.0, 30.0);
		hitBlk[i].glMoveTo(-100.0 + i*60.0, 0.0, -50.0);
		hitBlk[i].setMaterial(Green);
		window.entry(hitBlk[i]);
	}
	/////////////////////////////////////////////////////////////

	///////////////////////////////////////////////////////////////////////////
	// ԊǗp̕ϐ
	fk_Vector	vSpd, vPos;	// xxNgAʒu擾pϐ
	int			iState = 0;	// 0: ӂ, 1: ㏸, 2: ~
	int			dashFrm = 0;
	fk_Vector	vDashVec;
	///////////////////////////////////////////////////////////////////////////

	// JOŒ`
	fk_Model	camera;

	window.setCameraModel(camera);
	camera.glMoveTo(0.0, 100.0, 400.0);
	camera.glFocus(0.0, 0.0, 0.0);
	camera.setParent(&body);
	// J`܂

	//AUDIOAUDIOAUDIOAUDIOAUDIOAUDIOAUDIOAUDIOAUDIOAUDIOAUDIOAUDIOAUDIOAUDIOAUDIOAUDIOAUDIO//
	// TEh֌W
	fk_AudioStream		bgm;
	fk_AudioWavBuffer	se0, se1, se3D;
	bool				bgm_play, se0_play, se1_play, se3D_play;

	if(!bgm.open("BGM\\stage_01.ogg")) {
		fl_alert("bgm open failed.");	// ǂݍ݂ɎsG[bZ[Wo
	}
	bgm.setLoopMode(true);

	if(!se0.open("drum\\BDTIGHT2.wav")) {
		fl_alert("se0 open failed.");	// ǂݍ݂ɎsG[bZ[Wo
	}
	if(!se1.open("drum\\SDCRKRM.wav")) {
		fl_alert("se1 open failed.");	// ǂݍ݂ɎsG[bZ[Wo
	}
	if(!se3D.open("SE\\iPhone.wav")) {
		fl_alert("se3D open failed.");	// ǂݍ݂ɎsG[bZ[Wo
	}
	se3D.setLoopMode(true);
	se3D.setPosition(fk_Vector(0.0, 0.0, 0.0));
	se3D.setReferenceDist(100.0);
	se3D.setListenerModel(body);

	bgm_play = false;
	se0_play = false;
	se1_play = false;
	se3D_play = false;
	// TEh֌W܂
	//AUDIOAUDIOAUDIOAUDIOAUDIOAUDIOAUDIOAUDIOAUDIOAUDIOAUDIOAUDIOAUDIOAUDIOAUDIOAUDIOAUDIO//

	//2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D//
	// Go
	fkut_SpriteModel	spr, text, numSpr;

	// ǂݍ
	if(spr.readPNG("grp/hit.png") == false) {
		fl_alert("hit.png read error!");
	}
	// \(J͐ɐݒ肵ĂȂƂ)
	window.entry(spr);

	spr.glMoveTo(50.0, 50.0, 0.0);
	spr.setScale(2.0);

	// ǂݍ
	if(numSpr.readPNG("grp/pop_font.png") == false) {
		fl_alert("pop_font.png read error!");
	}
	// ؂o
	numSpr.setSpriteArea(56, 0, 28, 38);
	// ړ
	numSpr.setPositionLT(-400.0, 300.0);
	// \
	window.entry(numSpr);

	// 
	if(text.initFont("C:/WINDOWS/Fonts/Meiryo.ttc") == false) {
		fl_alert("initFont() error!");
	}
	// SpriteModel̕ϐ.text.TextImageNX̊֐()
	text.text.setPTSize(36);
	// `
	text.drawText("[\n");
	text.drawText("ǉ邼[");
	// l\peXgR[h
	int iValue = 256;
	text.drawText(fk_StrPrintf("XRA: %d \n", iValue), true);	// 
	text.drawText(fk_StrPrintf("~: %f", 3.14));	// 
	// fk_StrPrintf̒g̏́uprintf vł
	// ړ
	text.glTranslate(100.0, 0.0, 0.0);
	// \
	window.entry(text);
	//2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D//

	/*
	// wiɉ摜~
	fk_RectTexture	rect;
	fk_Model		bgModel;

	// 摜ǂݍ
	if(rect.readJPG("grp/wp.jpg") == false) {
		fl_alert("BG Read Error!");
	}
	rect.setTextureSize(1000.0, 750.0);
	rect.setTexRendMode(FK_TEX_REND_SMOOTH);
	rect.setTextureMode(FK_TEX_REPLACE);
	bgModel.setShape(&rect);
	bgModel.glMoveTo(0.0, 0.0, -1000.0);
	bgModel.setParent(&camera);
	window.entry(bgModel);
	*/

	//=========================================================================
	// 邮[
	while(window.update() == true) {
		// L[őOiށE(xx[XɕύX)
		vSpd.x = vSpd.z =  0.0;
		if(window.getSpecialKeyStatus(FK_UP) == FKUT_SW_PRESS) {
			vSpd.z = -1.0;
		}
		if(window.getSpecialKeyStatus(FK_DOWN) == FKUT_SW_PRESS) {
			vSpd.z =  1.0;
		}
		if(window.getSpecialKeyStatus(FK_LEFT) == FKUT_SW_PRESS) {
			vSpd.x = -1.0;
		}
		if(window.getSpecialKeyStatus(FK_RIGHT) == FKUT_SW_PRESS) {
			vSpd.x =  1.0;
		}
		if(window.getKeyStatus('x') == FKUT_SW_DOWN) {
			dashFrm = 30;
			vDashVec.set(vSpd.x, 0.0, vSpd.z);
		}
		if(dashFrm > 0) {
			vSpd.x += vDashVec.x*10.0*(double)dashFrm/30.0;
			vSpd.z += vDashVec.z*10.0*(double)dashFrm/30.0;
			dashFrm--;
		}
		// L[쏈܂

		/////////////////////////////////////////////////////////////
		// HWv
		if(iState == 0) {			// ʏ탂[h
			// zL[ꂽuԁA㏸[hֈڍs
			if(window.getKeyStatus('z') == FKUT_SW_DOWN) {
				iState = 1;
				vSpd.y = 10.0;		// Wv̏x^
			} else {
				vSpd.y = -0.5;
			}
		} else if(iState == 1) {	// ㏸[h
			// xω([Iȏd͉x^)
			if(vSpd.y > 4.0) {
				// ̑x邤͂߂Ɍ炷
				vSpd.y -= 1.0;
			} else if(vSpd.y > 0.0) {
				// xȂȂ猸炷ʂ炷
				vSpd.y -= 0.5;
			} else {
				// xɔ]牺~[hֈڍs
				iState = 2;
			}
		} else if(iState == 2) {	// ~[h
			// xω([Iȏd͉x^)
			if(vSpd.y > -4.0) {
				// ̑xȂ͂߂ɉ
				vSpd.y -= 0.5;
			} else {
				// xȂĂ炫߂ɉ
				vSpd.y -= 1.0;
			}
		}
		// Wv܂
		/////////////////////////////////////////////////////////////

		/////////////////////////////////////////////////////////////
		// ubNƂ̓蔻
		stand = false;
		for(int i = 0; i < 10; i++) {
			// ĂtrueԂ
			// (ړĂ画ł͂ȂAʒuƑxnɕύX)
			if(hitBlk[i].checkToMovingSphere(body, vSpd, back) == true) {
				// ubN猩߂肱݋backɓ̂ŁA
				// vC[𓮂Ēꍇ͋tɂȂ
				// \葬x(vSpd)ɑ΂ČZ
				vSpd -= back;

				// 蔻菈
				if(-back.y > 0.0) {	// ߂荞݂m
					vSpd.y = 0.0;	// xZbg
					iState = 0;		// ʏ탂[hֈڍs
					stand = true;
				}
			}
		}

		// L[Ad́AՓ˂ɂĕωxɂăfړ
		body.glTranslate(vSpd);

		// ʏ펞ɉ̗͂󂯂Ȃ牺~[hֈڍs
		if(iState == 0 && stand == false) {
			iState = 2;
		}

		// Ƃ̓蔻菈(OIȓ蔻Ȃ̂ł̂܂)
		vPos = body.getPosition();	// ݈ʒuĂ
		if(vPos.y < 0.0) {			// ɂ߂荞ł
			vSpd.y = 0.0;			// xZbg
			vPos.y = 0.0;			// YW0.0ɌŒ
			body.glMoveTo(vPos);	// Œ肵Wɋ]
			// ʏ탂[hֈڍs
			iState = 0;
		}
		/////////////////////////////////////////////////////////////

		//AUDIOAUDIOAUDIOAUDIOAUDIOAUDIOAUDIOAUDIOAUDIOAUDIOAUDIOAUDIO//
		// TEh֌W

		// ֐ƂȕɏI
		playSoundByKey(window, 'a', se0, se0_play);
		playSoundByKey(window, 's', se1, se1_play);

		/*
		// se0̃L[(a)ɂĐ
		if(window.getKeyStatus('a') == FKUT_SW_DOWN) {
			se0_play = true;
			se0.seek(0.0);
		}
		if(se0_play == true) {
			se0_play = se0.play();
		}
		// se1̃L[(s)ɂĐ
		if(window.getKeyStatus('s') == FKUT_SW_DOWN) {
			se1_play = true;
			se1.seek(0.0);
		}
		if(se1_play == true) {
			se1_play = se1.play();
		}
		*/

		// BGM̓Xy[XōĐƈꎞ~؂ւ
		if(window.getKeyStatus(' ') == FKUT_SW_DOWN) {
			if(bgm_play == true) {
				bgm_play = false;
				bgm.pause();
			} else {
				bgm_play = true;
			}
		}
		if(bgm_play == true) {
			bgm_play = bgm.play();
		}

		// ͏ɂ炸炵ςȂ
		// se3D.play();
		// TEh֌W܂
		//AUDIOAUDIOAUDIOAUDIOAUDIOAUDIOAUDIOAUDIOAUDIOAUDIOAUDIOAUDIO//
	}
	//=========================================================================
	// ꂳ܂ł

	return 0;
}
